//Legendes_302f.js
// 19.07.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Cre une lgende sous les blocs images

//Crdits:
//une extension du script "LabelGraphics.jsx" fourni par Adobe
//Initiant: Kai Rbsamen, D-35447 Reiskirchen, www.ruebiarts.de

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// mmoriser la version de l'application 
var appVers = app.version[0];
if (appVers == 4) {
	alert ("Ne pas utiliser ce script avec InDesign CS2.", "Stop");
	exit();
}
else if (appVers == 5) {
	// okay, CS3
}
else if (appVers == 6) {
	alert ("Ne pas utiliser ce script avec InDesign CS4.", "Stop");
	exit();
}
else {
	alert ("Ce script ne fonctionne pas avec cette version d'InDesign.", "Stop");
	exit();
}

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

var curDoc = app.documents[0];

if (curDoc.allGraphics.length == 0) {
	alert ("Ce document ne contient pas d'images.", "Stop");
	exit();
}

// mmoriser et tester la slection
var aSel = false;
var curSel = app.selection;
if (curSel.length == 0) {
	try {
		var testFrame = curDoc.textFrames.item("legende").fillColor;
		alert ("Il faut supprimer tous les blocs \"lgende\".", "Stop");
		exit();
	}
	catch (e) {
	}
	var graphicsList = curDoc.allGraphics;
}
else {
	var aSel = true;
	var nItems = curSel.length;
	var curItem;
	var tmpList;
	var graphicsList = new Array ();
	for (var i=0; i<nItems; i++) {
		curItem = curSel[i];
		if (curItem.constructor.name == "Rectangle") {
			graphicsList.push(curItem.allGraphics[0]);
		}
		else if (curItem.constructor.name == "Group") {
			tmpList = curItem.allGraphics;
			for (var k=0; k<tmpList.length; k++) {
				graphicsList.push(tmpList[k]);
			}
		}
	}
}

// appeler la fonction qui lit les prfrences mmorises
var tempFolder = "~/Library/Preferences/";
var labelDef = getDefs(tempFolder);

// extraire les valeurs mmorises
var labelType = 0;
var frameHeight = 8;
var frameOffset = 0;
var rndUnit = 3;
var paraStyle = objtStyle = "";
var pStyle = oStyle = 0;
var iLay = true;
if (labelDef != "") {
	var defVal = labelDef.split("\n");
	labelType = defVal[0]*1;
	frameHeight = defVal[1]*1;
	frameOffset = defVal[2]*1;
	rndUnit = defVal[3];
	if      (rndUnit == "0")  { rndUnit = 0; }
	else if (rndUnit == "1")  { rndUnit = 1; }
	else if (rndUnit == "2")  { rndUnit = 2; }
	else if (rndUnit == "4")  { rndUnit = 3; }
	else if (rndUnit == "5")  { rndUnit = 4; }
	else if (rndUnit == "10") { rndUnit = 5; }
	paraStyle = defVal[4];
	objtStyle = defVal[5];
	iLay = defVal[6];
	if (iLay == "true") {iLay = true;}
	else {iLay = false;}
}

// prparer le dialogue, l'afficher et convertir les valeurs
var labelWidth = 135;
var menuWidth = 250;
var labelList = new Array ("Le nom du fichier", "Le chemin du fichier", "XMP: la description", "XMP: l'auteur");
var styleNames = getParagraphStyleNames();
var nStyles = styleNames.length;
for (var i=0; i<nStyles; i++) {
	if (styleNames[i] == paraStyle) {
		pStyle = i;
		break;
	}
}
var objectNames = getObjectStyleNames();
var nStyles = objectNames.length;
for (var i=0; i<nStyles; i++) {
	if (objectNames[i] == objtStyle) {
		oStyle = i;
		break;
	}
}
var rndUnits = new Array ("", "1", "0.5", "0.25", "0.2", "0.1");
var rndValues = new Array (0, 1, 2, 4, 5, 10);

// effacer des dialogues rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

var aDialog = app.dialogs.add({name:"Crer des lgendes"});
with (aDialog.dialogColumns.add()) {
	// Art der Bildunterschrift
	with(dialogRows.add()) {
		with(dialogColumns.add()) {
			staticTexts.add({staticLabel:"Contenu", minWidth:labelWidth});
		}
		with(dialogColumns.add()) {
			var labelTypeDropdown = dropdowns.add({stringList:labelList, selectedIndex:labelType, minWidth:menuWidth});
		}
	}
	// la hauteur du bloc texte et le dcalage par rapport au bloc image
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			staticTexts.add({staticLabel:"Hauteur du bloc", minWidth:labelWidth});
			var labelHeightField = realEditboxes.add();
			labelHeightField.properties = {editValue:frameHeight, minimumValue:1, maximumValue:99, minWidth:36};
			staticTexts.add({staticLabel:"mm"});
			staticTexts.add({staticLabel:"Dcalage", minWidth:80});
			var labelOffsetField = realEditboxes.add({editValue:frameOffset, minWidth:36});
			staticTexts.add({staticLabel:"mm"});
		}
	}
	// l'unit d'arrondissement
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			staticTexts.add({staticLabel:"Arrondir ", minWidth:labelWidth});
			var labelRoundDropdown = dropdowns.add({stringList:rndUnits, selectedIndex:rndUnit, minWidth:39});
			staticTexts.add({staticLabel:"  (lors d'un surplus)"});
		}
	}
	// le style de paragraphes
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			with(dialogColumns.add()) {
				staticTexts.add({staticLabel:"Style de paragraphes", minWidth:labelWidth});
			}
			with(dialogColumns.add()) {
				var labelStyleDropdown = dropdowns.add({stringList:styleNames, selectedIndex:pStyle, minWidth:menuWidth});
			}
		}
	}
	// les styles d'objet
	with(dialogRows.add()) {
		with(dialogColumns.add()) {
			staticTexts.add({staticLabel:"Style d'objet", minWidth:labelWidth});
		}
		with(dialogColumns.add()) {
			var objectStyleDropdown = dropdowns.add({stringList:objectNames, selectedIndex:oStyle, minWidth:menuWidth});
		}
	}
	// case  cocher calque uniquement pour les lgendes
	with(dialogRows.add()) {
		staticTexts.add({staticLabel:"", minWidth:labelWidth});
		var layerCheckbox = checkboxControls.add({staticLabel:"les lgendes sur un calque spcial", checkedState:iLay});
	}
	with (aDialog.dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
var dResult = aDialog.show();
if(dResult == true) {
	var labelType = labelTypeDropdown.selectedIndex;
	var labelHeight = labelHeightField.editValue;
	var labelOffset = labelOffsetField.editValue;
	var rndVal = rndValues[labelRoundDropdown.selectedIndex];
	var labelStyle = styleNames[labelStyleDropdown.selectedIndex];
	var objectStyle = objectNames[objectStyleDropdown.selectedIndex];
	var indLayer = layerCheckbox.checkedState;
	aDialog.destroy();
}
else{
	aDialog.destroy();
	exit();
}

// crire le rsultat dans un fichier
var labelDef = ("" + labelType + "\n" + labelHeight + "\n" + labelOffset + "\n" 
+ rndVal + "\n" + labelStyle + "\n" + objectStyle + "\n" + indLayer);
writeDefs(tempFolder, labelDef);

// mmoriser les units
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// mettre l'origine des rgles  "Planches"
var rO = curDoc.viewPreferences.rulerOrigin;
if (rO != 1380143983) {
	curDoc.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
}

// slectionner le point de rfrence en haut au milieu
var trp = app.layoutWindows[0].transformReferencePoint;
if (trp != 1095660643) {
	app.layoutWindows[0].transformReferencePoint = 1095660643;
}

// appeler la fonction pour crer les lgendes
addLabels (labelType, labelHeight, labelOffset, rndVal, labelStyle, objectStyle);

// restaurer les units de mesure...
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
}

// ... l'origine des rgles...
if (rO != 1380143983) {
	try {
		curDoc.viewPreferences.rulerOrigin = rO;
	}
	catch (e) {
	}
}

// ... et le point de rfrence
if (trp != 1095660643) {
	app.layoutWindows[0].transformReferencePoint = trp;
}

// la fonction qui cre les lgendes
function addLabels(labelType, labelHeight, labelOffset, rndVal, labelStyleName, objectStyleName) {
	var actLayer = app.activeWindow.activeLayer;
	if (indLayer) {
		// crer le calque "legendes" (s'il n'existe pas)
		var labelLayer = curDoc.layers.item("legendes");
		try { 
			labelLayer.name;
		}
		catch (e) {
			labelLayer = curDoc.layers.add();
			labelLayer.name = "legendes";
		}
		app.activeWindow.activeLayer = labelLayer;
	}
	var curLayer = app.activeWindow.activeLayer;
	// mmoriser le verrouillage des calques, dverrouiller (si ncessaire)
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var layerLocks = new Array ();
	for (var i=0; i<nLayers; i++) {
		if (allLayers[i].locked == true) {
			allLayers[i].locked = false;
			layerLocks.push(true);
		}
		else {
			layerLocks.push(false);
		}
	}
	// prparer des variables
	labelStyle = curDoc.paragraphStyles.item(labelStyleName);
	objectStyle = curDoc.objectStyles.item(objectStyleName);
	var objSt = false;
	var curFrame, curLabel, curGraphic, curLink, curTextFrame, curPage, tmpFrame, tmpGroup;
	var testPar, pgNum, targetLoc, diff, lastBase, rot, lock, tmp;
	var vB, y1, x1, x2, bH, iS, vJ, bIns, allLabels, xvB;
	var curHeight, tstVal, intVal, decVal, rndVal, defHeight;
	// une boucle  travers les images
	for (var ctr=0; ctr<graphicsList.length; ctr++) {
		tmp = false;
		curGraphic = graphicsList[ctr];
		try {
			testPar = curGraphic.parent.parent.constructor.name;
			if (testPar == "Page" || testPar == "Spread" || testPar == "Group") {
				curLink = curGraphic.itemLink;
				// 'labelType' definit le contenu de la lgende
				if (labelType == 0) {
					curLabel = curLink.name; // nom du fichier
					if (curLabel.match(".pdf") || curLabel.match(".PDF")) {
						pgNum = curGraphic.pdfAttributes.pageNumber;
						if (pgNum > 1) {
							curLabel = curLabel + ":" + pgNum;
						}
					}
				}
				else if (labelType == 1) {
					curLabel = curLink.filePath; // chemin du fichier
					if (curLabel.match(".pdf") || curLabel.match(".PDF")) {
						pgNum = curGraphic.pdfAttributes.pageNumber;
						if (pgNum > 1) {
							curLabel = curLabel + ":" + pgNum;
						}
					}
				}
				else if (labelType == 2) {
					try {
						curLabel = curLink.linkXmp.description; // XMP: la description
					}
					catch (e) {
						curLabel = "";
					}
				}
				else if (labelType == 3) {
					try {
						curLabel = curLink.linkXmp.author; // XMP: l'auteur
					}
					catch (e) {
						curLabel = "";
					}
				}
				// le bloc de l'image actuelle
				curFrame = curGraphic.parent;
				rot = curFrame.rotationAngle;
				// si l'angle de rotation n'est pas zro...
				if (rot != 0) {
					testPar = curFrame.parent.constructor.name;
					// si le parent du bloc est "Page" ou "Planche"...
					if (testPar == "Page" || testPar == "Spread") {
						// ... tester le verrouillage...
						if (curFrame.locked == true) { 
							lock = true; 
							curFrame.locked = false; 
						}
						// ... mettre l'angle  zro
						curFrame.rotationAngle = 0;
					}
					// ... sinon le bloc fait partie d'uun groupe et on doit faire une copie temporaire
					else {
						tmp = true;
						tmpFrame = curFrame.duplicate();
						tmpFrame.rotationAngle = 0;
					}
					app.activeWindow.activeLayer = curFrame.itemLayer;
				}
				// mmoriser la position, de l'original ou de la copie
				if (!tmp) {
					vB = curFrame.visibleBounds;
				}
				else {
					vB = tmpFrame.visibleBounds;
				}
				// calculer les positions des bords du bloc lgende
				y1 = vB[2] + labelOffset;
				x1 = vB[1];
				x2 = vB[3];
				if (!tmp) {
					targetLoc = curFrame.parent;
				}
				else {
					targetLoc = tmpFrame.parent;
				}
				// une boucle, afin de pouvoir mmoriser la page ou la planche d'un bloc group
				for (var p=0; p<10; p++) {
					testPar = targetLoc.constructor.name;
					if (testPar == "Page" || testPar == "Spread") {
						// tester, si un bloc "lgende" se trouve  cette position...
						if (aSel) {
							try {
								allLabels = targetLoc.textFrames.item("legende").getElements();
								for (x=0; x<allLabels.length; x++) {
									xvB = allLabels[x].visibleBounds;
									if (xvB[0] > (y1-1) && xvB[0] < (y1+1)) {
										if (xvB[1] > (x1-1) && xvB[1] < (x1+1)) {
											try {
												if (allLabels[x].locked == true) {
													allLabels[x].locked = false;
												}
												allLabels[x].remove(); // ... et le supprimer
											}
											catch (e) {
											}
											break;
										}
									}
								}
							}
							catch (e) {
							}
						}
						curTextFrame = targetLoc.textFrames.add({visibleBounds:[y1, x1, y1+10, x2], contents:curLabel, label:"legende"});
						if (curLabel == "") {
							curTextFrame.parentStory.contents = "tmp";
						}
						break;
					}
					else {
						targetLoc = targetLoc.parent;
					}
				}
				// appliquer les style d'objet (ou le style de paragraphes et rgler la premire ligne de base)
				if (objectStyleName[0] == "[") {
					curTextFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
					curTextFrame.parentStory.texts.item(0).appliedParagraphStyle = labelStyle;
				}
				else {
					objSt = true;
					curTextFrame.appliedObjectStyle = objectStyle;
				}
				curTextFrame.visibleBounds = [y1, x1, y1+100, x2];
					// adapter le bloc au contenu
				curTextFrame.fit(FitOptions.FRAME_TO_CONTENT);
				// mmoriser les bounds et la justification verticale...
				vB = curTextFrame.visibleBounds;
				vJ = curTextFrame.textFramePreferences.verticalJustification;
				// ... ainsi que le retrait texte
				iS = curTextFrame.textFramePreferences.insetSpacing;
				if (iS.length == 4) {
					bIns = iS[2];
				}
				else {
					bIns = iS;
				}
				// ... et comparer la hauteur  la valeur demande
				curHeight = (vB[2]-vB[0]);
				if (curHeight <= labelHeight) { // wenn der Rahmen weniger hoch (oder gleich) ist, als gewnscht ...
					curTextFrame.visibleBounds = [y1, x1, y1+labelHeight, x2]; // ... auf die Hhe bringen
				}
				else { // si le bloc est plus haut ...
					if (vJ != 1651471469 && bIns == 0 && !objSt) { // ... justification verticale autre que "en bas", retrait texte en bas gal zro, pas de style d'objet...
						curLead = curTextFrame.parentStory.leading;
						if (curLead != 1635019116) {
							leadHalf = (curLead/2) * 0.353;
						}
						else {
							curSize = curTextFrame.parentStory.pointSize;
							curAuto = (curTextFrame.parentStory.autoLeading)/100;
							leadHalf = ((curSize*curAuto)/2) * 0.353;
						}
						if (rndVal == 0) { // ne pas arrondir
							curTextFrame.visibleBounds = [y1, x1, vB[0]+curHeight+leadHalf, x2]; // der Hhe den halben Zeilenabstand zugeben
						}
						else {
							defHeight = (Math.ceil((curHeight+leadHalf)*rndVal))/rndVal; // ajouter la moiti de l'interlignage  la hauteur et arrondir le rsultat
							curTextFrame.visibleBounds = [y1, x1, vB[0]+defHeight, x2];
						}
					}
					else {
						if (rndVal == 0) { //  ne pas arrondir
							curTextFrame.visibleBounds = [y1, x1, vB[0]+curHeight, x2];
						}
						else {
							defHeight = (Math.ceil(curHeight*rndVal))/rndVal;  // arrondir la hauteur actuelle
							curTextFrame.visibleBounds = [y1, x1, vB[0]+defHeight, x2];
						}
					}
				}
				// supprimer la chane temporaire s'il n'y avait pas de contenu
				if (curLabel == "") {
					try {
						curTextFrame.parentStory.remove();
					}
					catch (e) {
					}
				}
				// lorsque l'angle de rotation n'tait pas zro ...
				if (rot != 0) {
					// ... grouper, temporairement, le bloc image et le bloc lgende...
					curPage = curTextFrame.parent;
					if (!tmp) {
						tmpGroup = curPage.groups.add([curFrame, curTextFrame]);
					}
					else {
						tmpGroup = curPage.groups.add([tmpFrame, curTextFrame]);
					}
					// ... rtablir l'angle de rotation...
					tmpGroup.rotationAngle = rot;
					// ... et dgrouper
					tmpGroup.ungroup();
					// dplacer le bloc lgende au calque cible
					if (indLayer) {
						app.activeWindow.activeLayer = labelLayer;
						curTextFrame.move(labelLayer);
					}
					else {
						app.activeWindow.activeLayer = curLayer;
						curTextFrame.move(curLayer);
					}
					// supprimer un copie ventuelle du bloc image
					if (tmp) {
						tmpFrame.remove();
					}
					// rtablir le verrouillage (si ncessaire)
					if (lock) {
						curFrame.locked = true;
					}
				}
			}
		}
		catch (e) {
		}
	}
	// rtablir le verrouillage des calques (si ncessaire)
	for (var i=0; i<(nLayers); i++) {
		allLayers[i].locked = layerLocks[i];
	}
	// s'il y a plus d'un calque
	if (nLayers > 1) {
		// slectionner le calque qui tait slectionne initialement
		app.activeWindow.activeLayer = actLayer;
	}
}

// la fonction qui tablit la liste des styles de paragraphes
function getParagraphStyleNames() {
	return curDoc.paragraphStyles.everyItem().name;
}

// la fonction qui tablit la liste des styles d'objets
function getObjectStyleNames() {
	var allObjStyles = curDoc.objectStyles.everyItem().name;
	var nStyles = allObjStyles.length;
	var selStyles = new Array ();
	var curStyle;
	for (var i=0; i<nStyles; i++) {
		curStyle = allObjStyles[i];
		if (curStyle == "[None]") {
			selStyles.push("[Sans]");
		}
		else if (curStyle.indexOf("[Normal Text") != -1) {
			selStyles.push("[bloc de texte standard]");
		}
		else if (curStyle[0] != "[") {
			selStyles.push(curStyle);
		}
	}
	return selStyles;
}

// la fonction qui lit les valeurs mmorises
function getDefs(tempFolder) {
	var labelDef = "";
	var f = new File(tempFolder + "labelDef301.txt");
	fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			labelDef = (f.read());
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return labelDef;
}

// la fonction qui crit les valeurs mmorises dans un fichier
function writeDefs(tempFolder, labelDef) {
	var f = new File(tempFolder + "labelDef301.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(labelDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return fileIsOpen;
}